#ifndef DEBUG_H
#define DEBUG_H

////////////////////////////////////////////////////////////////////////////////
//  SoTerrain
////////////////////////////////////////////////////////////////////////////////
/// Obecn makra pro ladic vpisy.
/// \file debug.h
/// \author Radek Barto - xbarto33
/// \date 19.04.2005
///
/// Makra slouc k pomocnm vpism bhem ladn programu.
///////////////////////////////////////////////////////////////////////////////
//
// THIS SOFTWARE IS NOT COPYRIGHTED
//
// This source code is offered for use in the public domain.
//  You may use, modify or distribute it freely.
//
// This source code is distributed in the hope that it will be useful but
// WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
// DISCLAIMED.  This includes but is not limited to warranties of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
// If you find the source code useful, authors will kindly welcome
// if you give them credit and keep their names with their source code.
//
///////////////////////////////////////////////////////////////////////////////

// ostatni includy
#include <iostream>

/** Vpis ladic zprvy.
Zape na standardn vstup zprvu \p message ve formtu vhodnm pro ladn.
\param message Zprva pro ladic vpis. Me bt zapsna jako bn vraz nebo
(vzhledem k tomu, e to je makro) jako seznam identifiktor oddlench
opertorem <<. */
#ifdef DEBUG
  #define Debug(message) \
  { \
    std::cout << "DEBUG: " << "file " << __FILE__ << " at line " << __LINE__ \
      << " in " << __FUNCTION__ << ": " << #message << ": " << message << \
      std::endl; \
  }
#else
  #define Debug(message)
#endif

/** Zobrazen obsahu asociativnho pole.
Vype na standardn vstup obsah asociativnho pole \p map typu \p std::map
ve formtu vhodm pro ladn.
\param map Asociativn pole, jeho obsah se m vypsat.
\param iterator_type Typ itertoru, kter ma do asociativnho pole \p map pstup.
*/
#ifdef DEBUG
  #define DebugMap(map, iterator_type) \
  { \
    std::cout << "DEBUG: " << "file " << __FILE__ << " at line " << __LINE__ \
      << " in " << __FUNCTION__  << ": " << "polozky asociativniho pole " << \
      #map << ":" << std::endl; \
    t_size __tmp_index = 0; \
    for (iterator_type __tmp_it = map.begin(); __tmp_it != map.end(); \
      ++__tmp_it, ++__tmp_index) \
    { \
      std::cout << "\t" << __tmp_index + 1 << ". polozka: " << __tmp_it->first \
        << " hodnota: " << __tmp_it->second << std::endl; \
    } \
  }
#else
  #define DebugMap(map, iterator_type)
#endif

/** Zobrazeni obsahu vektoru.
Vype na standardn vstup obsah vektoru typu \p std::vector ve formtu
vhodm pro ladn.
\param vector Asociativn pole, jeho obsah se m vypsat.
\param iterator_type Typ itertoru, kter ma do vectoru \p vector pstup.
*/
#ifdef DEBUG
  #define DebugVec(vector, iterator_type) \
  { \
    std::cout << "DEBUG: " << "file " << __FILE__ << " at line " << __LINE__ \
      << " in " << __FUNCTION__  << ": " << "polozky vektoru " << #vector << ":" \
      << std::endl; \
    t_size __tmp_index = 0; \
    for (iterator_type __tmp_it = vector.begin(); __tmp_it != vector.end(); \
      ++__tmp_it, ++__tmp_index) \
    { \
      std::cout << "\t" << __tmp_index + 1 << ". polozka: " << *__tmp_it << \
      std::endl; \
    } \
  }
#else
  #define DebugVec(vector, iterator_type)
#endif

#endif
