#ifndef MAINPAGE_H
#define MAINPAGE_H

////////////////////////////////////////////////////////////////////////////////
//  SoTerrain
////////////////////////////////////////////////////////////////////////////////
/// Tituln strnka dokumentace.
/// \file mainpage.h
/// \author Radek Barto - xbarto33
/// \date 07.04.2006
///
/// Definice vzhledu tituln strnky dokumentace generovan systmem Doxygen.
///////////////////////////////////////////////////////////////////////////////
//
// THIS SOFTWARE IS NOT COPYRIGHTED
//
// This source code is offered for use in the public domain.
//  You may use, modify or distribute it freely.
//
// This source code is distributed in the hope that it will be useful but
// WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
// DISCLAIMED.  This includes but is not limited to warranties of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
// If you find the source code useful, authors will kindly welcome
// if you give them credit and keep their names with their source code.
//
///////////////////////////////////////////////////////////////////////////////

/** \mainpage SoTerrain
\section intro vod

\author Radek Barto (xbarto33)

Knihovna pro vizualizaci ternu v <A href="http://www.coin3d.org">Coin</A>
implementaci knihovny <A href="http://oss.sgi.com/projects/inventor/">Open
Inventor</A>. Definuje sadu uzl scny realizujcch vykreslovn vstupnch
vkovch map. Zatm se vstupn vkov mapy definuj jako matice bod v uzlech
::SoCoordinate3 pedazench pslunmu uzlu algoritmu v grafu scny,
ale v pozdjch implementacch toto me bt eeno jinak hlavn pro ely
zobrazovn "nekonenho" ternu.

\section features Vlastnosti
  - Implementace algoritmu ROAM.
    - Dv prioritn fronty zajiujc inkrementln generovn triangulace.
    - Oezvn pohledovm tlesem.
    - Nastaviteln maximln poet trojhelnk a chyba zobrazen v pixelech.
  - Implementace algoritmu Geo Mip-Mapping.
    - Oezvn pohledovm tlesem.
    - Nastaviteln velikost dladic a chyba zobrazen v pixelech.
  - Jednoduch profilovac knihovna.

  \image html hotovo.png "Ukzka oezvn pohledovm tlesem ternu vykreslenho algoritmem ROAM."

\section notes Poznmky k vydn
  - Verze pro bakalskou prci.
  - Licence: Public Domain
\section requirements Poadavky
  Tyto poadavky jsou pouze orientan, nebo jsou pouhm seznamem program a
  nstroj, na kterch byla knihovna vyzkouena.
  - Operan systm Linux:
    - Coin 2.4.4
    - SoQt 1.3.0
    - Qt 3.3.4
    - simage 1.6.1
    - GCC 3.3.6
    - GNU Make 3.80
    - Doxygen 1.4.4
  - Operan systm Windows:
    - Coin 2.4.4
    - SoQt 1.3.0
    - simage 1.6.1
    - Qt 3.3.6
    - Microsoft Visual Studio 6.0
*/
#endif