#ifndef UTILS_H
#define UTILS_H

////////////////////////////////////////////////////////////////////////////////
//  Integrovane vyvojove prostredi pro tvorbu a interpretaci konecnych automatu
////////////////////////////////////////////////////////////////////////////////
/// Obecn makra a funkce.
/// Hodnota zpracovanho prarametru.
/// \file utils.h
/// \author Radek Barto - xbarto33
/// \date 19.04.2005
///
/// Makra pro vemon ely.
///////////////////////////////////////////////////////////////////////////////
//
// THIS SOFTWARE IS NOT COPYRIGHTED
//
// This source code is offered for use in the public domain.
//  You may use, modify or distribute it freely.
//
// This source code is distributed in the hope that it will be useful but
// WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
// DISCLAIMED.  This includes but is not limited to warranties of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
// If you find the source code useful, authors will kindly welcome
// if you give them credit and keep their names with their source code.
//
///////////////////////////////////////////////////////////////////////////////

#include <stdio.h>

#include <debug.h>

/** Vpoet dvojkovho logaritmu celoselnho sla.
Vypote logaritmus celoselnho sla \p number se zkladem logaritmu 2.
Vsledek je opt celoseln a pedpokld se, ze slo \p number je nkterou
mocninou sla 2.
\param number slo, jeho logaritmus se m spotat.
\return Vypoten celoseln logaritmus se zkladem 2. */
inline int ilog2(int number)
{
  int tmp = number;
  int result = 0;
  while (tmp > 1)
  {
    result++;
    tmp >>= 1;
  }
  return result;
}

/// Hodnota zpracovanho prarametru.
extern char * optarg;

/** Zpracovn parametr programu.
Nhrada standardn funkce \p getopt pro prosted Microsoft Visual Studio.
\param argc Poet parametr programu.
\param argv Pole parametr programu.
\param optstring etzec popisujc zpracovvan parametry.
\return Znak zpracovanho parametru nebo \p -1, jsou-li vsechny parametry
zpracovny. */
int getopt(int argc, char * const argv[], const char * optstring);

#endif
