#!/bin/env python
# Name:    Performance test of SoTerrain library.
# Author:  Radek Barton
# E-mail:  blachex@post.cz
# Date:    3. 4. 2005
# Version: 0.1

from os import *
from os.path import *
from sys import *

from performance_values import *

system('make clean')
system('make profile')

# Additional testing options
options = '-f -v -s -F 1'

# Make all tests with testing prameters values.
for algorithm in algorithms:
  for landscape in landscapes:
    for animation_time in animation_times:
      if (algorithm == 'roam'):
        for triangle_count in triangle_counts:
          for pixel_error in pixel_errors:
            for I in xrange(10):
              profile_file = '%s-%s-%s-%s-%s-%d.txt' % (algorithm, landscape[0],
                animation_time, triangle_count, pixel_error, I)
              if not isfile('results/' + profile_file):
                command = './SoTerrainTest -a roam %s -h %s -t %s -A %s -r %s -e %s -p %s ' \
                  % (options, landscape[1], landscape[2], animation_time,
                  triangle_count, pixel_error, profile_file)
                print profile_file
                print command
                system(command)
                system('mv %s results/' % profile_file)
      elif (algorithm == 'geomipmapping'):
        for tile_size in tile_sizes:
          for pixel_error in pixel_errors:
            for I in xrange(10):
              profile_file = '%s-%s-%s-%s-%s-%d.txt' % (algorithm, landscape[0],
                animation_time, tile_size, pixel_error, I)
              if not isfile('results/' + profile_file):
                command = './SoTerrainTest -a geomipmapping %s -h %s -t %s -A %s -g %s -e %s -p %s' \
                  % (options, landscape[1], landscape[2], animation_time,
                   tile_size, pixel_error, profile_file)
                print profile_file
                system(command)
                system('mv %s results/' % profile_file)
      elif (algorithm == 'brutalforce'):
        for I in xrange(10):
          profile_file = '%s-%s-%s-%d.txt' % (algorithm, landscape[0],
            animation_time, I)
          if not isfile('results/' + profile_file):
            command = './SoTerrainTest %s -a brutalforce -h %s -t %s -A %s -p %s' % (options,
              landscape[1], landscape[2], animation_time, profile_file)
            print profile_file
            system(command)
            system('mv %s results/' % profile_file)
