///////////////////////////////////////////////////////////////////////////////
//  SoTerrain
///////////////////////////////////////////////////////////////////////////////
/// Testovac pklad profileru.
/// \file PrTest.cpp
/// \author Radek Barto - xbarto33
/// \date 26.06.2005
///
/// Ukzkov program slouc k demonstraci pouit a otestovn funknosti
/// profileru tdy ::PrProfiler.
///////////////////////////////////////////////////////////////////////////////
//
// THIS SOFTWARE IS NOT COPYRIGHTED
//
// This source code is offered for use in the public domain.
//  You may use, modify or distribute it freely.
//
// This source code is distributed in the hope that it will be useful but
// WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
// DISCLAIMED.  This includes but is not limited to warranties of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
// If you find the source code useful, authors will kindly welcome
// if you give them credit and keep their names with their source code.
//
///////////////////////////////////////////////////////////////////////////////

#include <profiler/PrProfiler.h>

int main(int argc, char * argv[])
{
  /* Inicializace profileru a nastaveni callbacku. */
  PR_INIT_PROFILER();
  /* Zacatek mereni vnejsiho algoritmu */
  PR_START_OBJ_PROFILE(for_loop, (void *)(1000));
  for (int I = 0; I < 10; ++I)
  {
    PR_START_PROFILE(for_loop_2);
    for (int J = 0; J < 10; ++J)
    {
      /* Mereni vnitrniho algoritmu. */
      PR_START_PROFILE(usleep);
      usleep(1000);
      PR_STOP_PROFILE(usleep);
    }
    PR_STOP_PROFILE(for_loop_2);
  }

  /* Konec mereni vnejsiho algoritmu. */
  PR_STOP_OBJ_PROFILE(for_loop, (void *)(1000));

  /* Tisk toho co zustalo v bufferu od posledniho callbacku. */
  PR_PRINT_RESULTS("result.txt");
}
