///////////////////////////////////////////////////////////////////////////////
//  SoTerrain
///////////////////////////////////////////////////////////////////////////////
/// Zkladn datov prvky algoritmu ROAM.
/// \file SbROAMPrimitives.cpp
/// \author Radek Barto - xbarto33
/// \date 16.09.2005
///
/// Algoritmus ROAM ve sv statick sti vyuv jako zkladn datovou
/// strukturu binrn strom trojhelnk. Pro tyto trojhelnky je zde
/// definovna tda ::SbROAMTriangle. V dynamick sti jsou pak poteba
/// dv prioritn fronty. Prvn z nich je prioritn fronta trojhelnk na
/// rozdlen. Obsahuje trojhelnky tdy ::SbROAMSplitQueueTriangle.
/// Druhou pak prioritn fronta trojhelnk na spojen. Ta obsahuje diamondy
/// (tveice trojhelnk) tdy ::SbROAMMergeQueueDiamond.
///////////////////////////////////////////////////////////////////////////////
//
// THIS SOFTWARE IS NOT COPYRIGHTED
//
// This source code is offered for use in the public domain.
//  You may use, modify or distribute it freely.
//
// This source code is distributed in the hope that it will be useful but
// WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
// DISCLAIMED.  This includes but is not limited to warranties of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
// If you find the source code useful, authors will kindly welcome
// if you give them credit and keep their names with their source code.
//
///////////////////////////////////////////////////////////////////////////////

#include <roam/SbROAMPrimitives.h>

/******************************************************************************
* SbROAMTriangle - public
******************************************************************************/

SbROAMTriangle::SbROAMTriangle(int _first, int _second, int _apex, int _level):
  first(_first), second(_second), apex(_apex), level(_level), error(0.0f),
  radius(0.0)
{
  // nic
}

/******************************************************************************
* SbROAMSplitQueueTriangle - public
******************************************************************************/

SbROAMSplitQueueTriangle::SbROAMSplitQueueTriangle(SbROAMTriangle * _triangle,
  float _priority, SbROAMSplitQueueTriangle * _left,
  SbROAMSplitQueueTriangle * _right, SbROAMSplitQueueTriangle * _base,
  SbROAMMergeQueueDiamond * _diamond):
  triangle(_triangle), left(_left), right(_right), base(_base),
  diamond(_diamond),  priority(-_priority), index(-1)
{
  // nic
}

/******************************************************************************
* SbROAMMergeQueueDiamond - public
******************************************************************************/

SbROAMMergeQueueDiamond::SbROAMMergeQueueDiamond(
  SbROAMSplitQueueTriangle * _first,
  SbROAMSplitQueueTriangle * _second,
  SbROAMSplitQueueTriangle * _third,
  SbROAMSplitQueueTriangle * _fourth,
  float _priority):
  first(_first), second(_second), third(_third), fourth(_fourth),
  priority(_priority), index(-1)
{
  // nic
}
